# US states laws

For US states laws, we recommend enabling [restricted data processing in ad requests](https://support.google.com/admanager/answer/9598414) to Google Ad Manager / AdSense when a user has opted out of personal data processing (selling, sharing, etc.).

This can be implemented by adding code on your website with the following logic:

* [Disable initial ad loading](https://developers.google.com/publisher-tag/reference#googletag.PubAdsService_disableInitialLoad) on the page until [Didomi is ready](https://developers.didomi.io/cmp/web-sdk/reference/api#didomi-ready).
* Check if the regulation that applies is a US regulation and if the user has opted out via the Didomi API. [Enable restricted data processing](https://support.google.com/admanager/answer/9598414) in that case.
* [Load ads on the page](https://developers.google.com/publisher-tag/reference#googletag.PubAdsService_refresh).

### Code sample

{% hint style="danger" %}
The following code disables GPT automatic ad loading on page load and refreshes ads after Didomi is ready on the page.

This will interact with your existing GPT ad code and must be thoroughly tested on your website to confirm that the ads behave as expected in all regulations.
{% endhint %}

```javascript
window.googletag = window.googletag || { cmd: [] };

googletag.cmd.push(() => {
    // Disable initial load.
    // This prevents GPT from automatically fetching ads when display is called until Didomi is ready on the page
    googletag.pubads().disableInitialLoad();
    googletag.enableServices();
});

window.didomiOnReady = window.didomiOnReady || [];
window.didomiOnReady.push(function (Didomi) {
    const userStatus = window.Didomi.getCurrentUserStatus();

    if (
        userStatus.regulation == 'cpra'
        || userStatus.regulation == 'cpa'
        || userStatus.regulation == 'ucpa'
        || userStatus.regulation == 'ctdpa'
        || userStatus.regulation == 'vcdpa'
    ) {
        if (
            !!Object
                .values(userStatus.purposes)
                .find(purpose => purpose.enabled === false)
        ) {
            googletag.cmd.push(() => {
                // Enable restricted data processing
                googletag.pubads().setPrivacySettings({
                    'restrictDataProcessing': true
                });
            });
        }
    }

    // Refresh ads
    googletag.cmd.push(() => {
        googletag.pubads().refresh();
    });
});
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developers.didomi.io/cmp/web-sdk/third-parties/direct-integrations/google-ad-manager-adsense/us-states-laws.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
